Remove the Unicode alternative for ".." (#3894)
[ghc-hetmet.git] / boot
diff --git a/boot b/boot
index a21691f..70d99e6 100644 (file)
--- a/boot
+++ b/boot
@@ -1,31 +1,57 @@
-#! /bin/sh
-set -e
-
-# Check that we have all core packages.
-for dir in `cat libraries/core-packages`; do
-  if test ! -d libraries/$dir; then
-    echo "Looks like you're missing libraries/$dir, maybe you haven't done './darcs-all get'?" >&2
-    exit 1
-  fi
-done
-
-# We don't recurse into the library packages with autoreconf anymore,
-# so we have to do this manually. To avoid a strict dependency on
-# autoreconf, we are careful to call autoreconf only when configure
-# does not exist yet or the corresponding configure.ac/aclocal.m4 is
-# newer. This would be dead easy if every shell supported the "-nt"
-# option for "test", but this is not the case. The only portable
-# solution seems to be via find's "-newer" option or to basically give
-# up and replace find with perl: :-P
-#
-#   perl -e 'print "configure.ac\n" if -M "configure.ac" < -M "configure"'
-for dir in . libraries/*; do
-  if test -f $dir/configure.ac; then
-    ( cd $dir ; { test ! -f configure || test -n "`find -L configure.ac -newer configure`" || (test -f aclocal.m4 && test -n "`find -L aclocal.m4 -newer configure`"); } && autoreconf )
-  fi
-done
+#!/usr/bin/perl -w
+
+use strict;
+
+use Cwd;
+
+# Create libraries/*/{ghc.mk,GNUmakefile}
+system("/usr/bin/perl", "-w", "boot-pkgs") == 0
+    or die "Running boot-pkgs failed: $?";
+
+my $dir;
+my $curdir;
+
+$curdir = &cwd();
+
+# Check that we have all boot packages.
+open PACKAGES, "< packages";
+while (<PACKAGES>) {
+    if (/^#/) {
+        # Comment; do nothing
+    }
+    elsif (/^([a-zA-Z0-9\/.-]+) *[^ ]+ *[^ ]+$/) {
+        $dir = $1;
+        
+        # We would like to just check for an _darcs directory here, but in
+        # an lndir tree we avoid making _darcs directories, so it doesn't
+        # exist. We therefore require that every repo has a LICENSE file
+        # instead.
+        if (! -f "$dir/LICENSE") {
+            print STDERR "Error: $dir/LICENSE doesn't exist.\n";
+            die "Maybe you haven't done './darcs-all get'?";
+        }
+    }
+    elsif (/^([a-zA-Z0-9\/.-]+) *[^ ]+ *[^ ]+ *[^ ]+$/) {
+        # These are lines which refer to optional repositories, so their
+        # absence isn't an error.
+    }
+    else {
+        die "Bad line in packages file: $_";
+    }
+}
+close PACKAGES;
+
+# autoreconf everything that needs it.
+foreach $dir (".", glob("libraries/*/")) {
+    if (-f "$dir/configure.ac") {
+        print "Booting $dir\n";
+        chdir $dir;
+        system "autoreconf";
+        chdir $curdir;
+    }
+}
 
 # Alas, darcs doesn't handle file permissions, so fix a few of them.
-for f in boot darcs-all push-all validate; do
-  test -f $f && chmod +x $f
-done
+for my $file ("boot", "darcs-all", "push-all", "validate") {
+    chmod 0755, $file if -f $file;
+}